/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
	"time"
)

// checks if the LifecycleSettings type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &LifecycleSettings{}

// LifecycleSettings struct for LifecycleSettings
type LifecycleSettings struct {
	Name                    NullableString `json:"name,omitempty"`
	ApplicationId           *string        `json:"applicationId,omitempty"`
	EligibleRoleId          NullableString `json:"eligibleRoleId,omitempty"`
	SubscribedRoleId        NullableString `json:"subscribedRoleId,omitempty"`
	SelfSubscriptionGroupId NullableString `json:"selfSubscriptionGroupId,omitempty"`
	DeniedRoleId            NullableString `json:"deniedRoleId,omitempty"`
	AdminRoleId             NullableString `json:"adminRoleId,omitempty"`
	Id                      NullableString `json:"id,omitempty"`
	CreationTime            *time.Time     `json:"creationTime,omitempty"`
}

// NewLifecycleSettings instantiates a new LifecycleSettings object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewLifecycleSettings() *LifecycleSettings {
	this := LifecycleSettings{}
	return &this
}

// NewLifecycleSettingsWithDefaults instantiates a new LifecycleSettings object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewLifecycleSettingsWithDefaults() *LifecycleSettings {
	this := LifecycleSettings{}
	return &this
}

// GetName returns the Name field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *LifecycleSettings) GetName() string {
	if o == nil || IsNil(o.Name.Get()) {
		var ret string
		return ret
	}
	return *o.Name.Get()
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *LifecycleSettings) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Name.Get(), o.Name.IsSet()
}

// HasName returns a boolean if a field has been set.
func (o *LifecycleSettings) HasName() bool {
	if o != nil && o.Name.IsSet() {
		return true
	}

	return false
}

// SetName gets a reference to the given NullableString and assigns it to the Name field.
func (o *LifecycleSettings) SetName(v string) {
	o.Name.Set(&v)
}

// SetNameNil sets the value for Name to be an explicit nil
func (o *LifecycleSettings) SetNameNil() {
	o.Name.Set(nil)
}

// UnsetName ensures that no value is present for Name, not even an explicit nil
func (o *LifecycleSettings) UnsetName() {
	o.Name.Unset()
}

// GetApplicationId returns the ApplicationId field value if set, zero value otherwise.
func (o *LifecycleSettings) GetApplicationId() string {
	if o == nil || IsNil(o.ApplicationId) {
		var ret string
		return ret
	}
	return *o.ApplicationId
}

// GetApplicationIdOk returns a tuple with the ApplicationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *LifecycleSettings) GetApplicationIdOk() (*string, bool) {
	if o == nil || IsNil(o.ApplicationId) {
		return nil, false
	}
	return o.ApplicationId, true
}

// HasApplicationId returns a boolean if a field has been set.
func (o *LifecycleSettings) HasApplicationId() bool {
	if o != nil && !IsNil(o.ApplicationId) {
		return true
	}

	return false
}

// SetApplicationId gets a reference to the given string and assigns it to the ApplicationId field.
func (o *LifecycleSettings) SetApplicationId(v string) {
	o.ApplicationId = &v
}

// GetEligibleRoleId returns the EligibleRoleId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *LifecycleSettings) GetEligibleRoleId() string {
	if o == nil || IsNil(o.EligibleRoleId.Get()) {
		var ret string
		return ret
	}
	return *o.EligibleRoleId.Get()
}

// GetEligibleRoleIdOk returns a tuple with the EligibleRoleId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *LifecycleSettings) GetEligibleRoleIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.EligibleRoleId.Get(), o.EligibleRoleId.IsSet()
}

// HasEligibleRoleId returns a boolean if a field has been set.
func (o *LifecycleSettings) HasEligibleRoleId() bool {
	if o != nil && o.EligibleRoleId.IsSet() {
		return true
	}

	return false
}

// SetEligibleRoleId gets a reference to the given NullableString and assigns it to the EligibleRoleId field.
func (o *LifecycleSettings) SetEligibleRoleId(v string) {
	o.EligibleRoleId.Set(&v)
}

// SetEligibleRoleIdNil sets the value for EligibleRoleId to be an explicit nil
func (o *LifecycleSettings) SetEligibleRoleIdNil() {
	o.EligibleRoleId.Set(nil)
}

// UnsetEligibleRoleId ensures that no value is present for EligibleRoleId, not even an explicit nil
func (o *LifecycleSettings) UnsetEligibleRoleId() {
	o.EligibleRoleId.Unset()
}

// GetSubscribedRoleId returns the SubscribedRoleId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *LifecycleSettings) GetSubscribedRoleId() string {
	if o == nil || IsNil(o.SubscribedRoleId.Get()) {
		var ret string
		return ret
	}
	return *o.SubscribedRoleId.Get()
}

// GetSubscribedRoleIdOk returns a tuple with the SubscribedRoleId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *LifecycleSettings) GetSubscribedRoleIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.SubscribedRoleId.Get(), o.SubscribedRoleId.IsSet()
}

// HasSubscribedRoleId returns a boolean if a field has been set.
func (o *LifecycleSettings) HasSubscribedRoleId() bool {
	if o != nil && o.SubscribedRoleId.IsSet() {
		return true
	}

	return false
}

// SetSubscribedRoleId gets a reference to the given NullableString and assigns it to the SubscribedRoleId field.
func (o *LifecycleSettings) SetSubscribedRoleId(v string) {
	o.SubscribedRoleId.Set(&v)
}

// SetSubscribedRoleIdNil sets the value for SubscribedRoleId to be an explicit nil
func (o *LifecycleSettings) SetSubscribedRoleIdNil() {
	o.SubscribedRoleId.Set(nil)
}

// UnsetSubscribedRoleId ensures that no value is present for SubscribedRoleId, not even an explicit nil
func (o *LifecycleSettings) UnsetSubscribedRoleId() {
	o.SubscribedRoleId.Unset()
}

// GetSelfSubscriptionGroupId returns the SelfSubscriptionGroupId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *LifecycleSettings) GetSelfSubscriptionGroupId() string {
	if o == nil || IsNil(o.SelfSubscriptionGroupId.Get()) {
		var ret string
		return ret
	}
	return *o.SelfSubscriptionGroupId.Get()
}

// GetSelfSubscriptionGroupIdOk returns a tuple with the SelfSubscriptionGroupId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *LifecycleSettings) GetSelfSubscriptionGroupIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.SelfSubscriptionGroupId.Get(), o.SelfSubscriptionGroupId.IsSet()
}

// HasSelfSubscriptionGroupId returns a boolean if a field has been set.
func (o *LifecycleSettings) HasSelfSubscriptionGroupId() bool {
	if o != nil && o.SelfSubscriptionGroupId.IsSet() {
		return true
	}

	return false
}

// SetSelfSubscriptionGroupId gets a reference to the given NullableString and assigns it to the SelfSubscriptionGroupId field.
func (o *LifecycleSettings) SetSelfSubscriptionGroupId(v string) {
	o.SelfSubscriptionGroupId.Set(&v)
}

// SetSelfSubscriptionGroupIdNil sets the value for SelfSubscriptionGroupId to be an explicit nil
func (o *LifecycleSettings) SetSelfSubscriptionGroupIdNil() {
	o.SelfSubscriptionGroupId.Set(nil)
}

// UnsetSelfSubscriptionGroupId ensures that no value is present for SelfSubscriptionGroupId, not even an explicit nil
func (o *LifecycleSettings) UnsetSelfSubscriptionGroupId() {
	o.SelfSubscriptionGroupId.Unset()
}

// GetDeniedRoleId returns the DeniedRoleId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *LifecycleSettings) GetDeniedRoleId() string {
	if o == nil || IsNil(o.DeniedRoleId.Get()) {
		var ret string
		return ret
	}
	return *o.DeniedRoleId.Get()
}

// GetDeniedRoleIdOk returns a tuple with the DeniedRoleId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *LifecycleSettings) GetDeniedRoleIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.DeniedRoleId.Get(), o.DeniedRoleId.IsSet()
}

// HasDeniedRoleId returns a boolean if a field has been set.
func (o *LifecycleSettings) HasDeniedRoleId() bool {
	if o != nil && o.DeniedRoleId.IsSet() {
		return true
	}

	return false
}

// SetDeniedRoleId gets a reference to the given NullableString and assigns it to the DeniedRoleId field.
func (o *LifecycleSettings) SetDeniedRoleId(v string) {
	o.DeniedRoleId.Set(&v)
}

// SetDeniedRoleIdNil sets the value for DeniedRoleId to be an explicit nil
func (o *LifecycleSettings) SetDeniedRoleIdNil() {
	o.DeniedRoleId.Set(nil)
}

// UnsetDeniedRoleId ensures that no value is present for DeniedRoleId, not even an explicit nil
func (o *LifecycleSettings) UnsetDeniedRoleId() {
	o.DeniedRoleId.Unset()
}

// GetAdminRoleId returns the AdminRoleId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *LifecycleSettings) GetAdminRoleId() string {
	if o == nil || IsNil(o.AdminRoleId.Get()) {
		var ret string
		return ret
	}
	return *o.AdminRoleId.Get()
}

// GetAdminRoleIdOk returns a tuple with the AdminRoleId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *LifecycleSettings) GetAdminRoleIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.AdminRoleId.Get(), o.AdminRoleId.IsSet()
}

// HasAdminRoleId returns a boolean if a field has been set.
func (o *LifecycleSettings) HasAdminRoleId() bool {
	if o != nil && o.AdminRoleId.IsSet() {
		return true
	}

	return false
}

// SetAdminRoleId gets a reference to the given NullableString and assigns it to the AdminRoleId field.
func (o *LifecycleSettings) SetAdminRoleId(v string) {
	o.AdminRoleId.Set(&v)
}

// SetAdminRoleIdNil sets the value for AdminRoleId to be an explicit nil
func (o *LifecycleSettings) SetAdminRoleIdNil() {
	o.AdminRoleId.Set(nil)
}

// UnsetAdminRoleId ensures that no value is present for AdminRoleId, not even an explicit nil
func (o *LifecycleSettings) UnsetAdminRoleId() {
	o.AdminRoleId.Unset()
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *LifecycleSettings) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *LifecycleSettings) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *LifecycleSettings) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *LifecycleSettings) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *LifecycleSettings) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *LifecycleSettings) UnsetId() {
	o.Id.Unset()
}

// GetCreationTime returns the CreationTime field value if set, zero value otherwise.
func (o *LifecycleSettings) GetCreationTime() time.Time {
	if o == nil || IsNil(o.CreationTime) {
		var ret time.Time
		return ret
	}
	return *o.CreationTime
}

// GetCreationTimeOk returns a tuple with the CreationTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *LifecycleSettings) GetCreationTimeOk() (*time.Time, bool) {
	if o == nil || IsNil(o.CreationTime) {
		return nil, false
	}
	return o.CreationTime, true
}

// HasCreationTime returns a boolean if a field has been set.
func (o *LifecycleSettings) HasCreationTime() bool {
	if o != nil && !IsNil(o.CreationTime) {
		return true
	}

	return false
}

// SetCreationTime gets a reference to the given time.Time and assigns it to the CreationTime field.
func (o *LifecycleSettings) SetCreationTime(v time.Time) {
	o.CreationTime = &v
}

func (o LifecycleSettings) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o LifecycleSettings) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.Name.IsSet() {
		toSerialize["name"] = o.Name.Get()
	}
	if !IsNil(o.ApplicationId) {
		toSerialize["applicationId"] = o.ApplicationId
	}
	if o.EligibleRoleId.IsSet() {
		toSerialize["eligibleRoleId"] = o.EligibleRoleId.Get()
	}
	if o.SubscribedRoleId.IsSet() {
		toSerialize["subscribedRoleId"] = o.SubscribedRoleId.Get()
	}
	if o.SelfSubscriptionGroupId.IsSet() {
		toSerialize["selfSubscriptionGroupId"] = o.SelfSubscriptionGroupId.Get()
	}
	if o.DeniedRoleId.IsSet() {
		toSerialize["deniedRoleId"] = o.DeniedRoleId.Get()
	}
	if o.AdminRoleId.IsSet() {
		toSerialize["adminRoleId"] = o.AdminRoleId.Get()
	}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if !IsNil(o.CreationTime) {
		toSerialize["creationTime"] = o.CreationTime
	}
	return toSerialize, nil
}

type NullableLifecycleSettings struct {
	value *LifecycleSettings
	isSet bool
}

func (v NullableLifecycleSettings) Get() *LifecycleSettings {
	return v.value
}

func (v *NullableLifecycleSettings) Set(val *LifecycleSettings) {
	v.value = val
	v.isSet = true
}

func (v NullableLifecycleSettings) IsSet() bool {
	return v.isSet
}

func (v *NullableLifecycleSettings) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableLifecycleSettings(val *LifecycleSettings) *NullableLifecycleSettings {
	return &NullableLifecycleSettings{value: val, isSet: true}
}

func (v NullableLifecycleSettings) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableLifecycleSettings) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
